'use strict';

/* eslint-disable no-param-reassign */
var defaultWidth = 1;
var defaultStyle = 'solid';
var defaultColor = 'black';

var styles = ['solid', 'dotted', 'dashed'];

module.exports = function (root) {
  var nodes = root.first.nodes;

  var values = nodes.reduce(function (accum, node) {
    if (accum.width === undefined && node.type === 'number') {
      accum.width = Number(node.value);
    } else if (accum.style === undefined && node.type === 'word' && styles.indexOf(node.value) !== -1) {
      accum.style = node.value;
    } else if (accum.color === undefined && node.type === 'word' && node.isColor) {
      accum.color = node.value;
    } else {
      throw new Error('Unexpected value: ' + node);
    }
    return accum;
  }, {
    width: undefined,
    style: undefined,
    color: undefined
  });

  var _values$width = values.width,
      borderWidth = _values$width === undefined ? defaultWidth : _values$width,
      _values$style = values.style,
      borderStyle = _values$style === undefined ? defaultStyle : _values$style,
      _values$color = values.color,
      borderColor = _values$color === undefined ? defaultColor : _values$color;


  return { $merge: { borderWidth: borderWidth, borderStyle: borderStyle, borderColor: borderColor } };
};