'use strict';

/* eslint-disable no-param-reassign */
var _require = require('./util'),
    assertUptoNValuesOfType = _require.assertUptoNValuesOfType;

var defaultWrap = 'nowrap';
var defaultDirection = 'row';

var wraps = ['nowrap', 'wrap', 'wrap-reverse'];
var directions = ['row', 'row-reverse', 'column', 'column-reverse'];

module.exports = function (root) {
  var nodes = root.first.nodes;

  assertUptoNValuesOfType(2, 'word', nodes);

  var values = nodes.reduce(function (accum, node) {
    if (accum.wrap === undefined && wraps.indexOf(node.value) !== -1) {
      accum.wrap = node.value;
    } else if (accum.direction === undefined && directions.indexOf(node.value) !== -1) {
      accum.direction = node.value;
    } else {
      throw new Error('Unexpected value: ' + node);
    }
    return accum;
  }, {
    wrap: undefined,
    direction: undefined
  });

  var _values$wrap = values.wrap,
      flexWrap = _values$wrap === undefined ? defaultWrap : _values$wrap,
      _values$direction = values.direction,
      flexDirection = _values$direction === undefined ? defaultDirection : _values$direction;


  return { $merge: { flexWrap: flexWrap, flexDirection: flexDirection } };
};